#!/bin/bash

# kmodtool - Helper script for building kernel module RPMs
#            An original version appeared in Fedora. This version is
#            generally called only by the %kernel_module_package RPM macro
#            during the process of building Driver Update Packages (which
#            are also known as "kmods" in the Fedora community).
#
# Copyright (c) 2003-2010 Ville Skyttä <ville.skytta@iki.fi>,
#                         Thorsten Leemhuis <fedora@leemhuis.info>
#                         Jon Masters <jcm@redhat.com>
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

# Changelog:
#            2010/12/13 - VMware, Inc changes
#                       - Modified to handle our module/common package setup
#                       - and custom pre/post scripts
#
#            2010/07/28 - Add fixes for filelists in line with LF standard
#			- Remove now defunct "framepointer" kernel variant
#			- Change version to "rhel6-rh2" as a consequence.
#
#            2010/01/10 - Simplified for RHEL6. We are working on upstream
#                         moving to a newer format and in any case do not
#                         need to retain support for really old systems.

shopt -s extglob

myprog="kmodtool"
myver="rhel6-rh2"
knownvariants=@(debug|kdump)
kmod_name=
kver=
verrel=
variant=

get_verrel ()
{
  verrel=${1:-$(uname -r)}
  verrel=${verrel%%$knownvariants}
}

print_verrel ()
{
  get_verrel $@
  echo "${verrel}"
}

get_variant ()
{
  get_verrel $@
  variant=${1:-$(uname -r)}
  variant=${variant##$verrel}
  variant=${variant:-'""'}
}

print_variant ()
{
  get_variant $@
  echo "${variant}"
}

get_filelist() {
	local IFS=$'\n'
	filelist=($(cat))

	if [ ${#filelist[@]} -gt 0 ];
	then
		for ((n = 0; n < ${#filelist[@]}; n++));
		do
			line="${filelist[n]}"
			line=$(echo "$line" \
				| sed -e "s/%verrel/$verrel/g" \
				| sed -e "s/%variant/$variant/g" \
				| sed -e "s/%dashvariant/$dashvariant/g" \
				| sed -e "s/%dotvariant/$dotvariant/g" \
				| sed -e "s/\.%1/$dotvariant/g" \
				| sed -e "s/\-%1/$dotvariant/g" \
				| sed -e "s/%2/$verrel/g")
			echo "$line"
		done
	else
		echo "%defattr(644,root,root,755)"
		echo "/lib/modules/${verrel}${dotvariant}"
	fi
}
	

get_rpmtemplate ()
{
    local variant="${1}"
    local dashvariant="${variant:+-${variant}}"
    local dotvariant="${variant:+.${variant}}"

    echo "%package       -n kmod-${kmod_name}${dashvariant}"

    if [ -z "$kmod_provides_summary" ]; then
        echo "Summary:          The vsock kernel module built for the %{kernel_version} kernel."
    fi

    if [ -z "$kmod_provides_group" ]; then
        echo "Group:            System Environment/Kernel"
    fi

    if [ ! -z "$kmod_version" ]; then
        echo "Version: %{kmod_version}"
    fi

    if [ ! -z "$kmod_release" ]; then
        echo "Release: %{kmod_release}"
    fi
    
    # Turn of the internal dep generator so we will use the kmod scripts.
    echo "%global _use_internal_dependency_generator 0"

    cat <<EOF
Provides:         kernel-modules = ${verrel}${dotvariant}
Provides:         ${kmod_name}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
EOF

# VMware: Add an additional explicit requirement.  Our modules require
# others to function.  The Driver Update Program's process sets up
# Requires based on our functionn and checksums accordingly.  However,
# this allows a module built for flavor Y to satisfy the requirement
# for a module built for flavor X since all the checksums still match.

    cat <<EOF
%define kmp_version %version
Requires:  ${kmod_name}-common = %{?epoch:%{epoch}:}9.0.10
Requires: vmware-tools-vmci-kmp-%{type} = %{?epoch:%{epoch}:}9.3.20.0
Requires:  vmware-tools-foundation >= 0:8.6.0
Provides:  vmware-tools-vsock-kmp-%{type}
Provides:  vmware-tools-vsock-kmp
Requires(post):   /sbin/depmod
Requires(postun): /sbin/depmod
EOF

    if [ "no" != "$nobuildreqs" ]
    then
        echo "BuildRequires: kernel${dashvariant}-devel"
    fi

    if [ "" != "$override_preamble" ]
    then
        cat "$override_preamble"
    fi

cat <<EOF
%description   -n kmod-${kmod_name}${dashvariant}
 This package contains a pre-compiled vsock module for use with the %{kernel_version} kernel.   The vsock kernel module provides an interface similar to the Berkeley UNIX sockets interface for using the vmci device. The vsock module allows for socket based communication between processes in the virtual machine and on the host, as well as between processes in different virtual machines.
EOF

##############################################################################
## The following are not part of this script directly, they are scripts     ##
## that will be executed by RPM during various stages of package processing ##
##############################################################################

cat <<EOF
%post          -n kmod-${kmod_name}${dashvariant}
# Deconfigure if upgrading
if [ \$1 -gt 1 ]; then
   # If the type matches, stop the init script
   kmodType=\$( uname -r | perl -pe 's/^.*el6(.*?).*?$/$1/g' )
   if [ "\$kmodType" = "$variant" ]; then
      if [ -e /etc/init/vsock.conf ]; then
         /sbin/initctl stop vsock 2>/dev/null || /bin/true
      fi
   fi
fi

if [ -e "/boot/System.map-${verrel}${dotvariant}" ]; then
    /sbin/depmod -aeF "/boot/System.map-${verrel}${dotvariant}" "${verrel}${dotvariant}" > /dev/null || :
fi

modules=( \$(find /lib/modules/${verrel}${dotvariant}/extra/${kmod_name} | grep '\.ko$') )
# weak-modules prints out warnings we don't care about.  Redirect its
# output. Uncomment for debugging.
if [ -x "/sbin/weak-modules" ]; then
    printf '%s\n' "\${modules[@]}" \
    | /sbin/weak-modules --add-modules >/dev/null 2>&1
fi
EOF

cat <<EOF
# If the type matches, start the init script
kmodType=\$( uname -r | perl -pe 's/^.*el6(.*?).*?$/$1/g' )
if [ "\$kmodType" = "$variant" ]; then
   if [ -e /etc/init/vsock.conf ]; then
      /sbin/initctl start vsock || true
   else
      # Otherwise modprobe it to be sure the device is accessible.
      modprobe vsock || true
   fi
fi
EOF

cat <<EOF
%preun         -n kmod-${kmod_name}${dashvariant}
# Only deconfigure if we are erasing the package here... not if we are upgrading.
if [ \$1 = 0 ]; then
   # If the type matches, stop the init script
   kmodType=\$( uname -r | perl -pe 's/^.*el6(.*?).*?$/$1/g' )
   if [ "\$kmodType" = "$variant" ]; then
      if [ -e /etc/init/vsock.conf ]; then
         /sbin/initctl stop vsock 2>/dev/null || /bin/true
      fi
   fi
fi
rpm -ql kmod-${kmod_name}${dashvariant}-%{kmod_version}-%{kmod_release}.%{_arch} | grep '\.ko$' > /var/run/rpm-kmod-${kmod_name}${dashvariant}-modules
EOF
        
cat <<EOF
%postun        -n kmod-${kmod_name}${dashvariant}
if [ -e "/boot/System.map-${verrel}${dotvariant}" ]; then
    /sbin/depmod -aeF "/boot/System.map-${verrel}${dotvariant}" "${verrel}${dotvariant}" > /dev/null || :
fi

modules=( \$(cat /var/run/rpm-kmod-${kmod_name}${dashvariant}-modules) )
rm /var/run/rpm-kmod-${kmod_name}${dashvariant}-modules
# weak-modules prints out warnings we don't care about.  Redirect its
# output.  Uncomment for debugging.
if [ -x "/sbin/weak-modules" ]; then
    printf '%s\n' "\${modules[@]}" \
    | /sbin/weak-modules --remove-modules >/dev/null 2>&1
fi
EOF

echo "%files         -n kmod-${kmod_name}${dashvariant}"

if [ "" == "$override_filelist" ];
then
    echo "%defattr(644,root,root,755)"
    echo "/lib/modules/${verrel}${dotvariant}"
else
    cat "$override_filelist" | get_filelist
fi
echo "/usr/lib/vmware-tools/symvers"
}

print_rpmtemplate ()
{
  kmod_name="${1}"
  shift
  kver="${1}"
  get_verrel "${1}"
  shift
  if [ -z "${kmod_name}" ] ; then
    echo "Please provide the kmodule-name as first parameter." >&2
    exit 2
  elif [ -z "${kver}" ] ; then
    echo "Please provide the kver as second parameter." >&2
    exit 2
  elif [ -z "${verrel}" ] ; then
    echo "Couldn't find out the verrel." >&2
    exit 2
  fi
  
  for variant in "$@" ; do
      if [ "default" == "$variant" ];
      then
            get_rpmtemplate ""
      else
            get_rpmtemplate "${variant}"
      fi
  done
}

usage ()
{
  cat <<EOF
You called: ${invocation}

Usage: ${myprog} <command> <option>+
 Commands:
  verrel <uname>                               
    - Get "base" version-release.
  variant <uname>                               
    - Get variant from uname.
  rpmtemplate <mainpgkname> <uname> <variants> 
    - Return a template for use in a source RPM
  version  
    - Output version number and exit.
EOF
}

invocation="$(basename ${0}) $@"
while [ "${1}" ] ; do
  case "${1}" in
    verrel)
      shift
      print_verrel $@
      exit $?
      ;;
    variant)
      shift
      print_variant $@
      exit $?
      ;;
    rpmtemplate)
      shift
      print_rpmtemplate "$@"
      exit $?
      ;;
    version)
      echo "${myprog} ${myver}"
      exit 0
      ;;
    *)
      echo "Error: Unknown option '${1}'." >&2
      usage >&2
      exit 2
      ;;
  esac
done

# Local variables:
# mode: sh
# sh-indentation: 2
# indent-tabs-mode: nil
# End:
# ex: ts=2 sw=2 et
